"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.typings.ts
var index_typings_exports = {};
__export(index_typings_exports, {
  Action: () => Action,
  App: () => App,
  ContractSwitchReason: () => ContractSwitchReason,
  ContractSwitchType: () => ContractSwitchType,
  DeleteStatus: () => DeleteStatus,
  DiscountType: () => DiscountType,
  Initiator: () => Initiator,
  IntervalUnit: () => IntervalUnit,
  Namespace: () => Namespace,
  PriceIncreaseTrigger: () => PriceIncreaseTrigger,
  ProductAdjustment: () => ProductAdjustment,
  ProgramStatus: () => ProgramStatus,
  ProviderName: () => ProviderName,
  ReactivationReasonEnum: () => ReactivationReasonEnum,
  SiteCreatedContext: () => SiteCreatedContext,
  State: () => State,
  SubscriptionStatus: () => SubscriptionStatus,
  Type: () => Type,
  UnassignReason: () => UnassignReason,
  WebhookIdentityType: () => WebhookIdentityType,
  activateReferralProgram: () => activateReferralProgram2,
  bulkGetReferralProgram: () => bulkGetReferralProgram2,
  generateAiSocialMediaPostsSuggestions: () => generateAiSocialMediaPostsSuggestions2,
  getAiSocialMediaPostsSuggestions: () => getAiSocialMediaPostsSuggestions2,
  getReferralProgram: () => getReferralProgram2,
  getReferralProgramPremiumFeatures: () => getReferralProgramPremiumFeatures2,
  pauseReferralProgram: () => pauseReferralProgram2,
  updateReferralProgram: () => updateReferralProgram2
});
module.exports = __toCommonJS(index_typings_exports);

// src/loyalty-referral-v1-program-programs.universal.ts
var import_transform_error = require("@wix/sdk-runtime/transform-error");
var import_rename_all_nested_keys = require("@wix/sdk-runtime/rename-all-nested-keys");

// src/loyalty-referral-v1-program-programs.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_float2 = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_field_mask = require("@wix/sdk-runtime/transformations/field-mask");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/referral-programs",
        destPath: ""
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    _: [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_referral_programs";
function getReferralProgram(payload) {
  function __getReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getReferralProgram;
}
function bulkGetReferralProgram(payload) {
  function __bulkGetReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.BulkGetReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/bulk/programs",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "programInSites.referralProgram.createdDate" },
            { path: "programInSites.referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __bulkGetReferralProgram;
}
function updateReferralProgram(payload) {
  function __updateReferralProgram({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "mask" }]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "referralProgram.createdDate" },
          { path: "referralProgram.updatedDate" }
        ]
      },
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          {
            path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
          },
          {
            path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
          },
          {
            path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
          }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.UpdateReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updateReferralProgram;
}
function activateReferralProgram(payload) {
  function __activateReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.ActivateReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/activate",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __activateReferralProgram;
}
function pauseReferralProgram(payload) {
  function __pauseReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.PauseReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/pause",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __pauseReferralProgram;
}
function getAiSocialMediaPostsSuggestions(payload) {
  function __getAiSocialMediaPostsSuggestions({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetAISocialMediaPostsSuggestions",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/ai-social-media-posts-suggestions",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __getAiSocialMediaPostsSuggestions;
}
function generateAiSocialMediaPostsSuggestions(payload) {
  function __generateAiSocialMediaPostsSuggestions({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "POST",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GenerateAISocialMediaPostsSuggestions",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/ai-social-media-posts-suggestions",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __generateAiSocialMediaPostsSuggestions;
}
function getReferralProgramPremiumFeatures(payload) {
  function __getReferralProgramPremiumFeatures({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetReferralProgramPremiumFeatures",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/premium-features",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __getReferralProgramPremiumFeatures;
}

// src/loyalty-referral-v1-program-programs.universal.ts
var ProgramStatus = /* @__PURE__ */ ((ProgramStatus2) => {
  ProgramStatus2["UNKNOWN"] = "UNKNOWN";
  ProgramStatus2["DRAFT"] = "DRAFT";
  ProgramStatus2["ACTIVE"] = "ACTIVE";
  ProgramStatus2["PAUSED"] = "PAUSED";
  return ProgramStatus2;
})(ProgramStatus || {});
var Type = /* @__PURE__ */ ((Type2) => {
  Type2["UNKNOWN"] = "UNKNOWN";
  Type2["COUPON"] = "COUPON";
  Type2["LOYALTY_POINTS"] = "LOYALTY_POINTS";
  Type2["NOTHING"] = "NOTHING";
  return Type2;
})(Type || {});
var DiscountType = /* @__PURE__ */ ((DiscountType2) => {
  DiscountType2["UNKNOWN"] = "UNKNOWN";
  DiscountType2["FIXED_AMOUNT"] = "FIXED_AMOUNT";
  DiscountType2["PERCENTAGE"] = "PERCENTAGE";
  DiscountType2["FREE_SHIPPING"] = "FREE_SHIPPING";
  return DiscountType2;
})(DiscountType || {});
var Action = /* @__PURE__ */ ((Action2) => {
  Action2["UNKNOWN"] = "UNKNOWN";
  Action2["STORE_ORDER_PLACED"] = "STORE_ORDER_PLACED";
  Action2["PLAN_ORDERED"] = "PLAN_ORDERED";
  Action2["TICKET_ORDERED"] = "TICKET_ORDERED";
  Action2["SESSION_BOOKED"] = "SESSION_BOOKED";
  Action2["RESTAURANT_ORDER_PLACED"] = "RESTAURANT_ORDER_PLACED";
  Action2["ONLINE_PROGRAM_JOINED"] = "ONLINE_PROGRAM_JOINED";
  return Action2;
})(Action || {});
var App = /* @__PURE__ */ ((App2) => {
  App2["UNKNOWN"] = "UNKNOWN";
  App2["STORES"] = "STORES";
  App2["PRICING_PLANS"] = "PRICING_PLANS";
  App2["EVENTS"] = "EVENTS";
  App2["BOOKINGS"] = "BOOKINGS";
  App2["RESTAURANTS"] = "RESTAURANTS";
  App2["ONLINE_PROGRAMS"] = "ONLINE_PROGRAMS";
  return App2;
})(App || {});
var State = /* @__PURE__ */ ((State2) => {
  State2["UNKNOWN"] = "UNKNOWN";
  State2["ENABLED"] = "ENABLED";
  State2["DISABLED"] = "DISABLED";
  State2["PENDING"] = "PENDING";
  State2["DEMO"] = "DEMO";
  return State2;
})(State || {});
var SiteCreatedContext = /* @__PURE__ */ ((SiteCreatedContext2) => {
  SiteCreatedContext2["OTHER"] = "OTHER";
  SiteCreatedContext2["FROM_TEMPLATE"] = "FROM_TEMPLATE";
  SiteCreatedContext2["DUPLICATE_BY_SITE_TRANSFER"] = "DUPLICATE_BY_SITE_TRANSFER";
  SiteCreatedContext2["DUPLICATE"] = "DUPLICATE";
  SiteCreatedContext2["OLD_SITE_TRANSFER"] = "OLD_SITE_TRANSFER";
  SiteCreatedContext2["FLASH"] = "FLASH";
  return SiteCreatedContext2;
})(SiteCreatedContext || {});
var Namespace = /* @__PURE__ */ ((Namespace2) => {
  Namespace2["UNKNOWN_NAMESPACE"] = "UNKNOWN_NAMESPACE";
  Namespace2["WIX"] = "WIX";
  Namespace2["SHOUT_OUT"] = "SHOUT_OUT";
  Namespace2["ALBUMS"] = "ALBUMS";
  Namespace2["WIX_STORES_TEST_DRIVE"] = "WIX_STORES_TEST_DRIVE";
  Namespace2["HOTELS"] = "HOTELS";
  Namespace2["CLUBS"] = "CLUBS";
  Namespace2["ONBOARDING_DRAFT"] = "ONBOARDING_DRAFT";
  Namespace2["DEV_SITE"] = "DEV_SITE";
  Namespace2["LOGOS"] = "LOGOS";
  Namespace2["VIDEO_MAKER"] = "VIDEO_MAKER";
  Namespace2["PARTNER_DASHBOARD"] = "PARTNER_DASHBOARD";
  Namespace2["DEV_CENTER_COMPANY"] = "DEV_CENTER_COMPANY";
  Namespace2["HTML_DRAFT"] = "HTML_DRAFT";
  Namespace2["SITELESS_BUSINESS"] = "SITELESS_BUSINESS";
  Namespace2["CREATOR_ECONOMY"] = "CREATOR_ECONOMY";
  Namespace2["DASHBOARD_FIRST"] = "DASHBOARD_FIRST";
  Namespace2["ANYWHERE"] = "ANYWHERE";
  Namespace2["HEADLESS"] = "HEADLESS";
  Namespace2["ACCOUNT_MASTER_CMS"] = "ACCOUNT_MASTER_CMS";
  Namespace2["RISE"] = "RISE";
  Namespace2["BRANDED_FIRST"] = "BRANDED_FIRST";
  Namespace2["NOWNIA"] = "NOWNIA";
  Namespace2["UGC_TEMPLATE"] = "UGC_TEMPLATE";
  Namespace2["CODUX"] = "CODUX";
  Namespace2["MEDIA_DESIGN_CREATOR"] = "MEDIA_DESIGN_CREATOR";
  Namespace2["SHARED_BLOG_ENTERPRISE"] = "SHARED_BLOG_ENTERPRISE";
  Namespace2["STANDALONE_FORMS"] = "STANDALONE_FORMS";
  Namespace2["STANDALONE_EVENTS"] = "STANDALONE_EVENTS";
  Namespace2["MIMIR"] = "MIMIR";
  return Namespace2;
})(Namespace || {});
var DeleteStatus = /* @__PURE__ */ ((DeleteStatus2) => {
  DeleteStatus2["UNKNOWN"] = "UNKNOWN";
  DeleteStatus2["TRASH"] = "TRASH";
  DeleteStatus2["DELETED"] = "DELETED";
  DeleteStatus2["PENDING_PURGE"] = "PENDING_PURGE";
  DeleteStatus2["PURGED_EXTERNALLY"] = "PURGED_EXTERNALLY";
  return DeleteStatus2;
})(DeleteStatus || {});
var ProviderName = /* @__PURE__ */ ((ProviderName2) => {
  ProviderName2["UNKNOWN"] = "UNKNOWN";
  ProviderName2["SBS"] = "SBS";
  ProviderName2["LICENSER"] = "LICENSER";
  ProviderName2["BASS"] = "BASS";
  ProviderName2["RESELLER"] = "RESELLER";
  ProviderName2["RECURRING_INVOICES"] = "RECURRING_INVOICES";
  return ProviderName2;
})(ProviderName || {});
var IntervalUnit = /* @__PURE__ */ ((IntervalUnit2) => {
  IntervalUnit2["UNKNOWN"] = "UNKNOWN";
  IntervalUnit2["DAY"] = "DAY";
  IntervalUnit2["WEEK"] = "WEEK";
  IntervalUnit2["MONTH"] = "MONTH";
  IntervalUnit2["YEAR"] = "YEAR";
  return IntervalUnit2;
})(IntervalUnit || {});
var SubscriptionStatus = /* @__PURE__ */ ((SubscriptionStatus2) => {
  SubscriptionStatus2["UNKNOWN"] = "UNKNOWN";
  SubscriptionStatus2["AUTO_RENEW_ON"] = "AUTO_RENEW_ON";
  SubscriptionStatus2["AUTO_RENEW_OFF"] = "AUTO_RENEW_OFF";
  SubscriptionStatus2["MANUAL_RECURRING"] = "MANUAL_RECURRING";
  SubscriptionStatus2["CANCELLED"] = "CANCELLED";
  SubscriptionStatus2["TRANSFERRED"] = "TRANSFERRED";
  return SubscriptionStatus2;
})(SubscriptionStatus || {});
var ReactivationReasonEnum = /* @__PURE__ */ ((ReactivationReasonEnum2) => {
  ReactivationReasonEnum2["UNKNOWN"] = "UNKNOWN";
  ReactivationReasonEnum2["BILLING_STATUS_CHANGE"] = "BILLING_STATUS_CHANGE";
  ReactivationReasonEnum2["REACTIVATED_AFTER_CHARGEBACK"] = "REACTIVATED_AFTER_CHARGEBACK";
  return ReactivationReasonEnum2;
})(ReactivationReasonEnum || {});
var Initiator = /* @__PURE__ */ ((Initiator2) => {
  Initiator2["UNKNOWN"] = "UNKNOWN";
  Initiator2["USER_REQUESTED"] = "USER_REQUESTED";
  Initiator2["APP_MANAGED"] = "APP_MANAGED";
  Initiator2["PASSIVE"] = "PASSIVE";
  return Initiator2;
})(Initiator || {});
var UnassignReason = /* @__PURE__ */ ((UnassignReason2) => {
  UnassignReason2["UNKNOWN"] = "UNKNOWN";
  UnassignReason2["USER_REQUESTED"] = "USER_REQUESTED";
  UnassignReason2["REPLACED_BY_ANOTHER_SUBSCRIPTION"] = "REPLACED_BY_ANOTHER_SUBSCRIPTION";
  return UnassignReason2;
})(UnassignReason || {});
var ContractSwitchType = /* @__PURE__ */ ((ContractSwitchType2) => {
  ContractSwitchType2["NOT_APPLICABLE"] = "NOT_APPLICABLE";
  ContractSwitchType2["ADDITIONAL_QUANTITY"] = "ADDITIONAL_QUANTITY";
  ContractSwitchType2["CREDIT_UNUSED_PERIOD"] = "CREDIT_UNUSED_PERIOD";
  ContractSwitchType2["REFUND_PRICE_DIFF"] = "REFUND_PRICE_DIFF";
  ContractSwitchType2["ADJUST_PERIOD_END"] = "ADJUST_PERIOD_END";
  ContractSwitchType2["DOWNGRADE_GRACE_PERIOD"] = "DOWNGRADE_GRACE_PERIOD";
  ContractSwitchType2["FULL_AMOUNT_PERIOD"] = "FULL_AMOUNT_PERIOD";
  ContractSwitchType2["END_OF_PERIOD"] = "END_OF_PERIOD";
  ContractSwitchType2["PENDING_CHANGES"] = "PENDING_CHANGES";
  ContractSwitchType2["DOWNGRADE_RENEWAL"] = "DOWNGRADE_RENEWAL";
  return ContractSwitchType2;
})(ContractSwitchType || {});
var ContractSwitchReason = /* @__PURE__ */ ((ContractSwitchReason2) => {
  ContractSwitchReason2["EXTERNAL_PROVIDER_TRIGGER"] = "EXTERNAL_PROVIDER_TRIGGER";
  ContractSwitchReason2["PRICE_INCREASE"] = "PRICE_INCREASE";
  return ContractSwitchReason2;
})(ContractSwitchReason || {});
var PriceIncreaseTrigger = /* @__PURE__ */ ((PriceIncreaseTrigger2) => {
  PriceIncreaseTrigger2["NEAR_RENEWAL"] = "NEAR_RENEWAL";
  PriceIncreaseTrigger2["RECURRING_SUCCESS"] = "RECURRING_SUCCESS";
  PriceIncreaseTrigger2["MANUAL"] = "MANUAL";
  return PriceIncreaseTrigger2;
})(PriceIncreaseTrigger || {});
var ProductAdjustment = /* @__PURE__ */ ((ProductAdjustment2) => {
  ProductAdjustment2["NOT_APPLICABLE"] = "NOT_APPLICABLE";
  ProductAdjustment2["DOWNGRADE"] = "DOWNGRADE";
  return ProductAdjustment2;
})(ProductAdjustment || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function getReferralProgram2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({});
  const reqOpts = getReferralProgram(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function bulkGetReferralProgram2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({});
  const reqOpts = bulkGetReferralProgram(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function updateReferralProgram2(referralProgram) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    referralProgram
  });
  const reqOpts = updateReferralProgram(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { referralProgram: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["referralProgram"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function activateReferralProgram2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({});
  const reqOpts = activateReferralProgram(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function pauseReferralProgram2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({});
  const reqOpts = pauseReferralProgram(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function getAiSocialMediaPostsSuggestions2(options) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    topic: options?.topic
  });
  const reqOpts = getAiSocialMediaPostsSuggestions(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { topic: "$[0].topic" },
        singleArgumentUnchanged: false
      },
      ["options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function generateAiSocialMediaPostsSuggestions2(options) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    topic: options?.topic
  });
  const reqOpts = generateAiSocialMediaPostsSuggestions(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { topic: "$[0].topic" },
        singleArgumentUnchanged: false
      },
      ["options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function getReferralProgramPremiumFeatures2() {
  const { httpClient, sideEffects } = arguments[0];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({});
  const reqOpts = getReferralProgramPremiumFeatures(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {},
        singleArgumentUnchanged: false
      },
      []
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Action,
  App,
  ContractSwitchReason,
  ContractSwitchType,
  DeleteStatus,
  DiscountType,
  Initiator,
  IntervalUnit,
  Namespace,
  PriceIncreaseTrigger,
  ProductAdjustment,
  ProgramStatus,
  ProviderName,
  ReactivationReasonEnum,
  SiteCreatedContext,
  State,
  SubscriptionStatus,
  Type,
  UnassignReason,
  WebhookIdentityType,
  activateReferralProgram,
  bulkGetReferralProgram,
  generateAiSocialMediaPostsSuggestions,
  getAiSocialMediaPostsSuggestions,
  getReferralProgram,
  getReferralProgramPremiumFeatures,
  pauseReferralProgram,
  updateReferralProgram
});
//# sourceMappingURL=index.typings.js.map