"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// meta.ts
var meta_exports = {};
__export(meta_exports, {
  activateReferralProgram: () => activateReferralProgram2,
  bulkGetReferralProgram: () => bulkGetReferralProgram2,
  generateAiSocialMediaPostsSuggestions: () => generateAiSocialMediaPostsSuggestions2,
  getAiSocialMediaPostsSuggestions: () => getAiSocialMediaPostsSuggestions2,
  getReferralProgram: () => getReferralProgram2,
  getReferralProgramPremiumFeatures: () => getReferralProgramPremiumFeatures2,
  pauseReferralProgram: () => pauseReferralProgram2,
  updateReferralProgram: () => updateReferralProgram2
});
module.exports = __toCommonJS(meta_exports);

// src/loyalty-referral-v1-program-programs.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_float2 = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_field_mask = require("@wix/sdk-runtime/transformations/field-mask");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/referral-programs",
        destPath: ""
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    _: [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_referral_programs";
function getReferralProgram(payload) {
  function __getReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getReferralProgram;
}
function bulkGetReferralProgram(payload) {
  function __bulkGetReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.BulkGetReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/bulk/programs",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "programInSites.referralProgram.createdDate" },
            { path: "programInSites.referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __bulkGetReferralProgram;
}
function updateReferralProgram(payload) {
  function __updateReferralProgram({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "mask" }]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "referralProgram.createdDate" },
          { path: "referralProgram.updatedDate" }
        ]
      },
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          {
            path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
          },
          {
            path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
          },
          {
            path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
          }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.UpdateReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updateReferralProgram;
}
function activateReferralProgram(payload) {
  function __activateReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.ActivateReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/activate",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __activateReferralProgram;
}
function pauseReferralProgram(payload) {
  function __pauseReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.PauseReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/pause",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __pauseReferralProgram;
}
function getAiSocialMediaPostsSuggestions(payload) {
  function __getAiSocialMediaPostsSuggestions({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetAISocialMediaPostsSuggestions",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/ai-social-media-posts-suggestions",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __getAiSocialMediaPostsSuggestions;
}
function generateAiSocialMediaPostsSuggestions(payload) {
  function __generateAiSocialMediaPostsSuggestions({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "POST",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GenerateAISocialMediaPostsSuggestions",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/ai-social-media-posts-suggestions",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __generateAiSocialMediaPostsSuggestions;
}
function getReferralProgramPremiumFeatures(payload) {
  function __getReferralProgramPremiumFeatures({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetReferralProgramPremiumFeatures",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/premium-features",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __getReferralProgramPremiumFeatures;
}

// src/loyalty-referral-v1-program-programs.meta.ts
function getReferralProgram2() {
  const payload = {};
  const getRequestOptions = getReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/program",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function bulkGetReferralProgram2() {
  const payload = {};
  const getRequestOptions = bulkGetReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/bulk/programs",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function updateReferralProgram2() {
  const payload = {};
  const getRequestOptions = updateReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/v1/program",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function activateReferralProgram2() {
  const payload = {};
  const getRequestOptions = activateReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/v1/program/activate",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function pauseReferralProgram2() {
  const payload = {};
  const getRequestOptions = pauseReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/v1/program/pause",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getAiSocialMediaPostsSuggestions2() {
  const payload = {};
  const getRequestOptions = getAiSocialMediaPostsSuggestions(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/program/ai-social-media-posts-suggestions",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function generateAiSocialMediaPostsSuggestions2() {
  const payload = {};
  const getRequestOptions = generateAiSocialMediaPostsSuggestions(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/program/ai-social-media-posts-suggestions",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getReferralProgramPremiumFeatures2() {
  const payload = {};
  const getRequestOptions = getReferralProgramPremiumFeatures(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/program/premium-features",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  activateReferralProgram,
  bulkGetReferralProgram,
  generateAiSocialMediaPostsSuggestions,
  getAiSocialMediaPostsSuggestions,
  getReferralProgram,
  getReferralProgramPremiumFeatures,
  pauseReferralProgram,
  updateReferralProgram
});
//# sourceMappingURL=meta.js.map