// src/loyalty-referral-v1-program-programs.http.ts
import { toURLSearchParams } from "@wix/sdk-runtime/rest-modules";
import { transformSDKFloatToRESTFloat } from "@wix/sdk-runtime/transformations/float";
import { transformRESTFloatToSDKFloat } from "@wix/sdk-runtime/transformations/float";
import { transformSDKTimestampToRESTTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformRESTTimestampToSDKTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformSDKFieldMaskToRESTFieldMask } from "@wix/sdk-runtime/transformations/field-mask";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/referral-programs",
        destPath: ""
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    _: [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/_api/referral-programs",
        destPath: ""
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_referral_programs";
function getReferralProgram(payload) {
  function __getReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getReferralProgram;
}
function bulkGetReferralProgram(payload) {
  function __bulkGetReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.BulkGetReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/bulk/programs",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "programInSites.referralProgram.createdDate" },
            { path: "programInSites.referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "programInSites.referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "programInSites.referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __bulkGetReferralProgram;
}
function updateReferralProgram(payload) {
  function __updateReferralProgram({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "mask" }]
      },
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "referralProgram.createdDate" },
          { path: "referralProgram.updatedDate" }
        ]
      },
      {
        transformFn: transformSDKFloatToRESTFloat,
        paths: [
          {
            path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
          },
          {
            path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
          },
          {
            path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
          },
          {
            path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
          }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.UpdateReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updateReferralProgram;
}
function activateReferralProgram(payload) {
  function __activateReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.ActivateReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/activate",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __activateReferralProgram;
}
function pauseReferralProgram(payload) {
  function __pauseReferralProgram({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "PATCH",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.PauseReferralProgram",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/pause",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "referralProgram.createdDate" },
            { path: "referralProgram.updatedDate" }
          ]
        },
        {
          transformFn: transformRESTFloatToSDKFloat,
          paths: [
            {
              path: "referralProgram.referredFriendReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referredFriendReward.couponOptions.percentageOptions.percentage"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.minimumSubtotal"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.fixedAmountOptions.amount"
            },
            {
              path: "referralProgram.referringCustomerReward.couponOptions.percentageOptions.percentage"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __pauseReferralProgram;
}
function getAiSocialMediaPostsSuggestions(payload) {
  function __getAiSocialMediaPostsSuggestions({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetAISocialMediaPostsSuggestions",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/ai-social-media-posts-suggestions",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload)
    };
    return metadata;
  }
  return __getAiSocialMediaPostsSuggestions;
}
function generateAiSocialMediaPostsSuggestions(payload) {
  function __generateAiSocialMediaPostsSuggestions({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "POST",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GenerateAISocialMediaPostsSuggestions",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/ai-social-media-posts-suggestions",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __generateAiSocialMediaPostsSuggestions;
}
function getReferralProgramPremiumFeatures(payload) {
  function __getReferralProgramPremiumFeatures({ host }) {
    const metadata = {
      entityFqdn: "wix.loyalty.referral.v1.program",
      method: "GET",
      methodFqn: "wix.loyalty.referral.program.v1.ReferralPrograms.GetReferralProgramPremiumFeatures",
      packageName: PACKAGE_NAME,
      url: resolveWixLoyaltyReferralProgramV1ReferralProgramsUrl({
        protoPath: "/v1/program/premium-features",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload)
    };
    return metadata;
  }
  return __getReferralProgramPremiumFeatures;
}

// src/loyalty-referral-v1-program-programs.meta.ts
function getReferralProgram2() {
  const payload = {};
  const getRequestOptions = getReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/program",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function bulkGetReferralProgram2() {
  const payload = {};
  const getRequestOptions = bulkGetReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/bulk/programs",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function updateReferralProgram2() {
  const payload = {};
  const getRequestOptions = updateReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/v1/program",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function activateReferralProgram2() {
  const payload = {};
  const getRequestOptions = activateReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/v1/program/activate",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function pauseReferralProgram2() {
  const payload = {};
  const getRequestOptions = pauseReferralProgram(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/v1/program/pause",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getAiSocialMediaPostsSuggestions2() {
  const payload = {};
  const getRequestOptions = getAiSocialMediaPostsSuggestions(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/program/ai-social-media-posts-suggestions",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function generateAiSocialMediaPostsSuggestions2() {
  const payload = {};
  const getRequestOptions = generateAiSocialMediaPostsSuggestions(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/program/ai-social-media-posts-suggestions",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getReferralProgramPremiumFeatures2() {
  const payload = {};
  const getRequestOptions = getReferralProgramPremiumFeatures(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/program/premium-features",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
export {
  activateReferralProgram2 as activateReferralProgram,
  bulkGetReferralProgram2 as bulkGetReferralProgram,
  generateAiSocialMediaPostsSuggestions2 as generateAiSocialMediaPostsSuggestions,
  getAiSocialMediaPostsSuggestions2 as getAiSocialMediaPostsSuggestions,
  getReferralProgram2 as getReferralProgram,
  getReferralProgramPremiumFeatures2 as getReferralProgramPremiumFeatures,
  pauseReferralProgram2 as pauseReferralProgram,
  updateReferralProgram2 as updateReferralProgram
};
//# sourceMappingURL=meta.mjs.map